(use test)
(use magic-pipes-runtime)

(test-group
 "alists"

 (test "alist-modify"
       '((a . 1) (b . 3) (c . 3))
       (alist-modify (list
                      (cons 'b (lambda (x) (+ x 1)))
                      (cons 'd (lambda (x) (* x 2))))
                     '((a . 1) (b . 2) (c . 3))))

  (test "alist-modifier"
       '((a . 1) (b . 3) (c . 3))
       ((alist-modifier (list
                         (cons 'b (lambda (x) (+ x 1)))
                         (cons 'd (lambda (x) (* x 2)))))
        '((a . 1) (b . 2) (c . 3))))

   (test "alist-project"
       '((a . 1) (c . 3) (d . 4))
       (alist-project '(a c (d . 4))
                      '((a . 1) (b . 2) (c . 3))))

   (test "alist-projector"
         '((a . 1) (c . 3) (d . 4))
         ((alist-projector '(a c (d . 4)))
          '((a . 1) (b . 2) (c . 3))))


 )
